%define         _hardened_build 1

Summary: DjVu viewers, encoders, and utilities
Name: djvulibre
Version: 3.5.28
Release: 2%{?dist}
License: GPLv2+
URL: http://djvu.sourceforge.net/
Source0: http://downloads.sourceforge.net/djvu/%{name}-%{version}.tar.gz
Patch0: djvulibre-3.5.22-cdefs.patch
Patch6: djvulibre-3.5.27-export-file.patch
Patch8: djvulibre-3.5.27-check-image-size.patch
Patch9: djvulibre-3.5.27-integer-overflow.patch
Patch10: djvulibre-3.5.27-check-input-pool.patch
Patch11: djvulibre-3.5.27-djvuport-stack-overflow.patch
Patch12: djvulibre-3.5.27-unsigned-short-overflow.patch
Patch14: djvulibre-3.5.27-out-of-bound-write-2.patch

Requires(post): xdg-utils
Requires(preun): xdg-utils
BuildRequires:  gcc
BuildRequires: libjpeg-turbo-devel
BuildRequires: libtiff-devel
BuildRequires: xdg-utils chrpath
BuildRequires: hicolor-icon-theme
BuildRequires: inkscape
BuildRequires: gcc-c++
BuildRequires: make

Provides: %{name}-mozplugin = %{version}

%description
DjVu is a web-centric format and software platform for distributing documents
and images. DjVu can advantageously replace PDF, PS, TIFF, JPEG, and GIF for
distributing scanned documents, digital documents, or high-resolution pictures.
DjVu content downloads faster, displays and renders faster, looks nicer on a
screen, and consume less client resources than competing formats. DjVu images
display instantly and can be smoothly zoomed and panned with no lengthy
re-rendering.

DjVuLibre is a free (GPL'ed) implementation of DjVu, including viewers,
decoders, simple encoders, and utilities. The browser plugin is in its own
separate sub-package.


%package libs
Summary: Library files for DjVuLibre

%description libs
Library files for DjVuLibre.


%package devel
Summary: Development files for DjVuLibre
Requires: %{name}-libs = %{version}-%{release}
Requires: pkgconfig

%description devel
Development files for DjVuLibre.


%prep
%setup -q 
%patch0 -p1 -b .cdefs
%patch6 -p1 -b .export-file
%patch8 -p1 -b .check-image-size
%patch9 -p1 -b .integer-overflow
%patch10 -p1 -b .check-input-pool
%patch11 -p1 -b .djvuport-stack-overflow
%patch12 -p1 -b .unsigned-short-overflow
%patch14 -p1 -b .out-of-bound-write-2


%build 
%configure --with-qt=%{_libdir}/qt-3.3 --enable-threads

make %{?_smp_mflags} V=1


%install
make install DESTDIR=%{buildroot}

find %{buildroot}%{_libdir} -name '*.so*' | xargs %{__chmod} +x

chrpath --delete %{buildroot}%{_bindir}/djvutoxml
chrpath --delete %{buildroot}%{_bindir}/djvused
chrpath --delete %{buildroot}%{_bindir}/cjb2
chrpath --delete %{buildroot}%{_bindir}/csepdjvu
chrpath --delete %{buildroot}%{_bindir}/djvuserve
chrpath --delete %{buildroot}%{_bindir}/djvm
chrpath --delete %{buildroot}%{_bindir}/djvuxmlparser
chrpath --delete %{buildroot}%{_bindir}/djvutxt
chrpath --delete %{buildroot}%{_bindir}/ddjvu
chrpath --delete %{buildroot}%{_bindir}/djvumake
chrpath --delete %{buildroot}%{_bindir}/cpaldjvu
chrpath --delete %{buildroot}%{_bindir}/djvuextract
chrpath --delete %{buildroot}%{_bindir}/c44
chrpath --delete %{buildroot}%{_bindir}/djvups
chrpath --delete %{buildroot}%{_bindir}/djvudump
chrpath --delete %{buildroot}%{_bindir}/djvmcvt
chrpath --delete %{buildroot}%{_bindir}/bzz

rm -f %{buildroot}%{_datadir}/mime/packages/djvulibre-mime.xml

pushd desktopfiles
for i in 22 32 48 64 ; do
    install -d %{buildroot}%{_datadir}/icons/hicolor/${i}x${i}/mimetypes/
    cp -a ./prebuilt-hi${i}-djvu.png %{buildroot}%{_datadir}/icons/hicolor/${i}x${i}/mimetypes/image-vnd.djvu.mime.png
done
popd


%post
rm -f %{_datadir}/applications/djvulibre-djview3.desktop || :
rm -f %{_datadir}/icons/hicolor/32x32/apps/djvulibre-djview3.png || :


%preun
if [ $1 -eq 0 ]; then
    %{_datadir}/djvu/osi/desktop/register-djvu-mime uninstall || :
fi




%files
%{_bindir}/*
%{_mandir}/man1/*
%{_datadir}/djvu/
%{_datadir}/icons/hicolor/16x16/mimetypes/*
%{_datadir}/icons/hicolor/20x20/mimetypes/*
%{_datadir}/icons/hicolor/22x22/mimetypes/*
%{_datadir}/icons/hicolor/24x24/mimetypes/*
%{_datadir}/icons/hicolor/32x32/mimetypes/*
%{_datadir}/icons/hicolor/48x48/mimetypes/*
%{_datadir}/icons/hicolor/64x64/mimetypes/*
%{_datadir}/icons/hicolor/72x72/mimetypes/*
%{_datadir}/icons/hicolor/96x96/mimetypes/*
%{_datadir}/icons/hicolor/128x128/mimetypes/*
%{_datadir}/icons/hicolor/scalable/mimetypes/*
%{_datadir}/icons/hicolor/256x256/mimetypes/*


%files libs
%doc README COPYRIGHT COPYING NEWS
%{_libdir}/*.so.*


%files devel
%doc doc/*.*
%{_includedir}/libdjvu/
%{_libdir}/pkgconfig/ddjvuapi.pc
%exclude %{_libdir}/*.la
%{_libdir}/*.so


%changelog
* Thu May 09 2024 Doris Chao <doriscchao@tencent.com> - 3.5.28-2
- debrand for opencloudos

* Mon Apr 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.5.28-1
- initial build
